local main = CBMT
if not main then error("Main CBMT file not found. Something is wrong.") end
main.options = {
	type="group",
	args={
		spelltimers = {
			type="group",
			name="Spell timers",
			desc="Timers triggered on spell cast",
			order=1,
			args={},
		},
		auratimers = {
			type="group",
			name="Aura timers",
			desc="Timers triggered on (de-)buff applied/removed",
			order=2,
			args={},
		},
		yelltimers = {
			type="group",
			name="Chat message timers",
			desc="Timers triggered by a boss chat message",
			order=3,
			args={},
		},
		customtimers = {
			type="group",
			name="Custom timers",
			desc="Timers triggered by any event using custom LUA code",
			order=-1,
			args={},
		},
	},
}
LibStub("AceConfig-3.0"):RegisterOptionsTable("CBMT", main.options)
local drop_spell_1,drop_spell_2={spellID="Spell ID #", spellName="Spell name", delete="Delete this filter",},{spellID="Spell ID #", spellName="Spell name",}
function main:updateOptions()
	for n=1, (#main.opt.timersSpellcast+1) do
		if not main.options.args.spelltimers.args["timer"..n] then
			main.options.args.spelltimers.args["timer"..n] = {
				type="group",
				name=function()
					if not main.opt.timersSpellcast[n] then
						return "New filter"
					end
					if main.opt.timersSpellcast[n].spellFilterType == "spellID" then
						return main.opt.timersSpellcast[n].spellID and "Spell #"..main.opt.timersSpellcast[n].spellID or "Unconfigured Spell ID filter"
					end
					if main.opt.timersSpellcast[n].spellFilterType == "spellName" then
						return main.opt.timersSpellcast[n].spellName and "Spell: "..main.opt.timersSpellcast[n].spellName or "Unconfigured Spell name filter"
					end
				end,
				args={
					dropdown={
						order=1,
						type="select",
						name="Filter type",
						values=function() return main.opt.timersSpellcast[n] and drop_spell_1 or drop_spell_2 end,
						get=function() return main.opt.timersSpellcast[n] and main.opt.timersSpellcast[n].spellFilterType or "" end,
						set=function(info, value) if value=="delete" then tremove(main.opt.timersSpellcast, n) return end main.opt.timersSpellcast[n] = main.opt.timersSpellcast[n] or {} main.opt.timersSpellcast[n].spellFilterType = value main:updateOptions() end,
					},
					filterSettings={
						order=2,
						type="group",
						name="Filter settings",
						dialogInline=true,
						hidden=function() return (not main.opt.timersSpellcast[n]) end,
						args={
							spellID={
								type="input",
								validate=function(info, value) if value=="" then return true end if (not tonumber(value)) or (not (select(2,pcall(GetSpellInfo,tonumber(value))))) then return "Error: Not a spell ID" end return true end,
								get=function() return main.opt.timersSpellcast[n] and tostring(main.opt.timersSpellcast[n].spellID or "") end,
								set=function(info, value) main.opt.timersSpellcast[n].spellID = tonumber(value) end,
								order=1,
								name="Spell ID #",
								width="full",
								hidden=function() return (not main.opt.timersSpellcast[n]) or (main.opt.timersSpellcast[n].spellFilterType ~= "spellID") end,
							},
							spellName={
								type="input",
								get=function() return main.opt.timersSpellcast[n] and main.opt.timersSpellcast[n].spellName or "" end,
								set=function(info, value) main.opt.timersSpellcast[n].spellName = value end,
								order=1,
								name="Spell name",
								width="full",
								hidden=function() return (not main.opt.timersSpellcast[n]) or (main.opt.timersSpellcast[n].spellFilterType ~= "spellName") end,
							},
							filterSrc={
								type="group",
								name="   ",
								args={
									doFilter={
										type="toggle",
										get=function() return main.opt.timersSpellcast[n] and main.opt.timersSpellcast[n].doFilterSrc end,
										set=function(info, value) main.opt.timersSpellcast[n].doFilterSrc = value end,
										order=1,
										name="Filter by cast source",
									},
									filterType={
										type="select",
										get=function() return main.opt.timersSpellcast[n].srcFilterType or "" end,
										set=function(info, value) main.opt.timersSpellcast[n].srcFilterType = value end,
										values={name="Filter by unit name", unitID="Filter by unit ID", npcID="Filter by NPC ID"},
										name="Filter type",
										hidden=function() return (not main.opt.timersSpellcast[n].doFilterSrc) end,
										order=2,
									},
									nameFilters={
										type="group",
										dialogInline=true,
										name=" ",
										order=3,
										width="full",
										hidden=function() return (main.opt.timersSpellcast[n].srcFilterType ~= "name") end,
										args={
											addName={
												order=1,
												type="input",
												name="Add name",
												get=function() return "" end,
												set=function(info, value) main.opt.timersSpellcast[n].srcFilterNames = main.opt.timersSpellcast[n].srcFilterNames or {} main.opt.timersSpellcast[n].srcFilterNames[value] = value end,
												width="full",
											},
											removeName={
												order=2,
												type="multiselect",
												name="Remove name",
												hidden=function() return (not main.opt.timersSpellcast[n].srcFilterNames) or (not next(main.opt.timersSpellcast[n].srcFilterNames, nil)) end,
												values=function() return main.opt.timersSpellcast[n].srcFilterNames end,
												width="full",
												get=function() return false end,
												set=function(info, name) main.opt.timersSpellcast[n].srcFilterNames[name] = nil end,
											},
										},
									},
									unitIDFilters={
										type="group",
										dialogInline=true,
										name=" ",
										order=3,
										width="full",
										hidden=function() return (main.opt.timersSpellcast[n].srcFilterType ~= "unitID") end,
										args={
											addUID={
												order=1,
												type="input",
												name="Add an unitID",
												get=function() return "" end,
												set=function(info, value) main.opt.timersSpellcast[n].srcFilterUnitIDs  = main.opt.timersSpellcast[n].srcFilterUnitIDs or {} main.opt.timersSpellcast[n].srcFilterUnitIDs[value] = value end,
												width="full",
											},
											removeUID={
												order=2,
												type="multiselect",
												name="Remove unitID",
												hidden=function() return (not main.opt.timersSpellcast[n].srcFilterUnitIDs) or (not next(main.opt.timersSpellcast[n].srcFilterUnitIDs,nil)) end,
												values=function() return main.opt.timersSpellcast[n].srcFilterUnitIDs end,
												width="full",
												get=function() return false end,
												set=function(info, uid) main.opt.timersSpellcast[n].srcFilterUnitIDs[uid] = nil end,
											},
										},
									},
									npcIDFilters={
										type="group",
										dialogInline=true,
										name=" ",
										order=3,
										width="full",
										hidden=function() return (main.opt.timersSpellcast[n].srcFilterType ~= "npcID") end,
										args={
											addNID={
												order=1,
												type="input",
												name="Add a NPC ID",
												get=function() return "" end,
												set=function(info, value) main.opt.timersSpellcast[n].srcFilterNPCs = main.opt.timersSpellcast[n].srcFilterNPCs or {} main.opt.timersSpellcast[n].srcFilterNPCs[value] = value end,
												width="full",
											},
											removeNID={
												order=2,
												type="multiselect",
												name="Remove NPC ID",
												hidden=function() return (not main.opt.timersSpellcast[n].srcFilterNPCs) or (not next(main.opt.timersSpellcast[n].srcFilterNPCs, nil)) end,
												values=function() return main.opt.timersSpellcast[n].srcFilterNPCs end,
												width="full",
												get=function() return false end,
												set=function(info, npcid) main.opt.timersSpellcast[n].srcFilterNPCs[npcid] = nil end,
											},
										},
									},
								},
							},
						},
					},
					barSettings={
						order=3,
						type="group",
						name="Bar settings",
						dialogInline=true,
						hidden=function() return (not main.opt.timersSpellcast[n]) end,
						args={
							label={
								type="input",
								get=function() return main.opt.timersSpellcast[n].timerName or "" end,
								set=function(info, value) main.opt.timersSpellcast[n].timerName = value end,
								order=1,
								name="Bar label",
							},
							--[[duration={
								type="input",
								get=function() return tostring(main.opt.timersSpellcast[n].timerDuration or "") end,
								set=function(info, value) main.opt.timersSpellcast[n].timerDuration = tonumber(value) end,
								order=2,
								name="Bar duration",
								--validate=function(info, value) if not tonumber(value) then print(value, tonumber(value)) return "Not a numeric value" end end,
							},--]]
							duration={
								type="range",
								name="Bar duration",
								min=0.1,
								softMax=1200,
								bigStep=1,
								get=function() return main.opt.timersSpellcast[n].timerDuration or 0 end,
								set=function(info, value) main.opt.timersSpellcast[n].timerDuration = value end,
								order=2,
							},
							allowMultiples = {
								type="toggle",
								name="Allow multiple instances",
								width="full",
								order=3,
								get=function() if type(main.opt.timersSpellcast[n].noMultiples) == "boolean" then return (not main.opt.timersSpelcast[n].noMultiples) else return true end end,
								set=function(info, value) main.opt.timersSpellcast[n].noMultiples = not value end,
							},
						},
					},
				},
				order=n,
				hidden=function() return ((#main.opt.timersSpellcast+1)<n) end,
			}
		end
	end
	for n=1, (#main.opt.timersAura+1) do
		if not main.options.args.auratimers.args["timer"..n] then
			main.options.args.auratimers.args["timer"..n] = {
				type="group",
				name=function()
					if not main.opt.timersAura[n] then
						return "New filter"
					end
					if main.opt.timersAura[n].auraFilterType == "spellID" then
						return main.opt.timersAura[n].spellID and "Aura #"..main.opt.timersAura[n].spellID or "Unconfigured Aura ID filter"
					end
					if main.opt.timersAura[n].auraFilterType == "spellName" then
						return main.opt.timersAura[n].spellName and "Aura: "..main.opt.timersAura[n].spellName or "Unconfigured Aura name filter"
					end
				end,
				args={
					dropdown={
						order=1,
						type="select",
						name="Filter type",
						values=function() return main.opt.timersAura[n] and drop_spell_1 or drop_spell_2 end,
						get=function() return main.opt.timersAura[n] and main.opt.timersAura[n].auraFilterType or "" end,
						set=function(info, value) if value == "delete" then tremove(main.opt.timersAura,n) return end main.opt.timersAura[n] = main.opt.timersAura[n] or {eventType={}} main.opt.timersAura[n].auraFilterType = value main:updateOptions() end,
					},
					filterSettings={
						order=2,
						type="group",
						name="Filter settings",
						dialogInline=true,
						hidden=function() return (not main.opt.timersAura[n]) end,
						args={
							spellID={
								type="input",
								validate=function(info, value) if value=="" then return true end if (not tonumber(value)) or (not (select(2,pcall(GetSpellInfo,tonumber(value))))) then return "Error: Not a spell ID" end return true end,
								get=function() return main.opt.timersAura[n] and tostring(main.opt.timersAura[n].spellID or "") end,
								set=function(info, value) main.opt.timersAura[n].spellID = tonumber(value) end,
								order=1,
								name="Spell ID #",
								width="full",
								hidden=function() return (not main.opt.timersAura[n]) or (main.opt.timersAura[n].auraFilterType ~= "spellID") end,
							},
							spellName={
								type="input",
								get=function() return main.opt.timersAura[n] and main.opt.timersAura[n].spellName or "" end,
								set=function(info, value) main.opt.timersAura[n].spellName = value end,
								order=1,
								name="Spell name",
								width="full",
								hidden=function() return (not main.opt.timersAura[n]) or (main.opt.timersAura[n].auraFilterType ~= "spellName") end,
							},
							eventType={
								type="multiselect",
								name="Aura event type",
								values={SPELL_AURA_APPLIED="Aura applied",SPELL_AURA_REFRESH="Aura refreshed",SPELL_AURA_REMOVED="Aura removed",SPELL_AURA_APPLIED_DOSE="Stack applied",SPELL_AURA_REMOVED_DOSE="Stack removed"},
								hidden=function() if main.opt.timersAura[n] then main.opt.timersAura[n].eventType=main.opt.timersAura[n].eventType or {} return false else return true end end,
								get=function(info, key) return main.opt.timersAura[n].eventType[key] end,
								set=function(info, key, value) main.opt.timersAura[n].eventType[key] = value end,
								order=2,
							},
							filterSrc={
								type="group",
								order=3,
								name="   ",
								args={
									doFilter={
										type="toggle",
										get=function() return main.opt.timersAura[n] and main.opt.timersAura[n].doFilterSrc end,
										set=function(info, value) main.opt.timersAura[n].doFilterSrc = value end,
										order=1,
										name="Filter by unit",
									},
									filterType={
										type="select",
										get=function() return main.opt.timersAura[n].srcFilterType or "" end,
										set=function(info, value) main.opt.timersAura[n].srcFilterType = value end,
										values={name="Filter by unit name", unitID="Filter by unit ID", npcID="Filter by NPC ID"},
										name="Filter type",
										hidden=function() return (not main.opt.timersAura[n].doFilterSrc) end,
										order=2,
									},
									nameFilters={
										type="group",
										dialogInline=true,
										name=" ",
										order=3,
										width="full",
										hidden=function() return (main.opt.timersAura[n].srcFilterType ~= "name") end,
										args={
											addName={
												order=1,
												type="input",
												name="Add name",
												get=function() return "" end,
												set=function(info, value) main.opt.timersAura[n].srcFilterNames = main.opt.timersAura[n].srcFilterNames or {} main.opt.timersAura[n].srcFilterNames[value] = value end,
												width="full",
											},
											removeName={
												order=2,
												type="multiselect",
												name="Remove name",
												hidden=function() return (not main.opt.timersAura[n].srcFilterNames) or (not next(main.opt.timersAura[n].srcFilterNames, nil)) end,
												values=function() return main.opt.timersAura[n].srcFilterNames end,
												width="full",
												get=function() return false end,
												set=function(info, name) main.opt.timersAura[n].srcFilterNames[name] = nil end,
											},
										},
									},
									unitIDFilters={
										type="group",
										dialogInline=true,
										name=" ",
										order=3,
										width="full",
										hidden=function() return (main.opt.timersAura[n].srcFilterType ~= "unitID") end,
										args={
											addUID={
												order=1,
												type="input",
												name="Add an unitID",
												get=function() return "" end,
												set=function(info, value) main.opt.timersAura[n].srcFilterUnitIDs  = main.opt.timersAura[n].srcFilterUnitIDs or {} main.opt.timersAura[n].srcFilterUnitIDs[value] = value end,
												width="full",
											},
											removeUID={
												order=2,
												type="multiselect",
												name="Remove unitID",
												hidden=function() return (not main.opt.timersAura[n].srcFilterUnitIDs) or (not next(main.opt.timersAura[n].srcFilterUnitIDs,nil)) end,
												values=function() return main.opt.timersAura[n].srcFilterUnitIDs end,
												width="full",
												get=function() return false end,
												set=function(info, uid) main.opt.timersAura[n].srcFilterUnitIDs[uid] = nil end,
											},
										},
									},
									npcIDFilters={
										type="group",
										dialogInline=true,
										name=" ",
										order=3,
										width="full",
										hidden=function() return (main.opt.timersAura[n].srcFilterType ~= "npcID") end,
										args={
											addNID={
												order=1,
												type="input",
												name="Add a NPC ID",
												get=function() return "" end,
												set=function(info, value) main.opt.timersAura[n].srcFilterNPCs = main.opt.timersAura[n].srcFilterNPCs or {} main.opt.timersAura[n].srcFilterNPCs[value] = value end,
												width="full",
											},
											removeNID={
												order=2,
												type="multiselect",
												name="Remove NPC ID",
												hidden=function() return (not main.opt.timersAura[n].srcFilterNPCs) or (not next(main.opt.timersAura[n].srcFilterNPCs, nil)) end,
												values=function() return main.opt.timersAura[n].srcFilterNPCs end,
												width="full",
												get=function() return false end,
												set=function(info, npcid) main.opt.timersAura[n].srcFilterNPCs[npcid] = nil end,
											},
										},
									},
								},
							},
						},
					},
					barSettings={
						order=3,
						type="group",
						name="Bar settings",
						dialogInline=true,
						hidden=function() return (not main.opt.timersAura[n]) end,
						args={
							label={
								type="input",
								get=function() return main.opt.timersAura[n].timerName or "" end,
								set=function(info, value) main.opt.timersAura[n].timerName = value end,
								order=1,
								name="Bar label",
							},
							duration={
								type="range",
								name="Bar duration",
								min=0.1,
								softMax=1200,
								bigStep=1,
								get=function() return main.opt.timersAura[n].timerDuration or 0 end,
								set=function(info, value) main.opt.timersAura[n].timerDuration = value end,
								order=2,
							},
							allowMultiples={
								type="toggle",
								name="Allow multiple instances",
								order=3,
								width="full",
								get=function() if type(main.opt.timersAura[n].noMultiples) == "boolean" then return (not main.opt.timersAura[n].noMultiples) else return true end end,
								set=function(info, value) main.opt.timersAura[n].noMultiples = not value end,
							},
						},
					},
				},
			}
		end
	end
	for n=1, (#main.opt.timersMobyell+1) do
		if not main.options.args.yelltimers.args["timer"..n] then
			main.options.args.yelltimers.args["timer"..n] = {
				type="group",
				name=function()
					if not main.opt.timersMobyell[n] then
						return "New filter"
					end
					if main.opt.timersMobyell[n].filterSource and main.opt.timersMobyell[n].sourceNames and next(main.opt.timersMobyell[n].sourceNames,nil) then
						local r
						for mobName in pairs(main.opt.timersMobyell[n].sourceNames) do
							r=r and r.."|"..mobName or mobName
						end
						return r
					end
					if main.opt.timersMobyell[n].messageFilter and (strlen(main.opt.timersMobyell[n].messageFilter)>0) then
						return "Message: "..main.opt.timersMobyell[n].messageFilter
					end
					return "Unconfigured message filter"
				end,
				hidden=function() return ((#main.opt.timersMobyell+1)<n) end,
				order=n,
				args={
					barSettings={
						type="group",
						name="Bar settings",
						order=1,
						dialogInline=true,
						args={
							timerName = {
								type="input",
								order=1,
								name="Bar label",
								get=function() return main.opt.timersMobyell[n] and main.opt.timersMobyell[n].timerName or "" end,
								set=function(info, value) if not main.opt.timersMobyell[n] then main.opt.timersMobyell[n] = {timerName=value, sourceNames = {}} main:updateOptions() else main.opt.timersMobyell[n].timerName = value end end,
							},
							timerDuration = {
								type="range",
								name="Bar duration",
								min=0.1,
								softMax=1200,
								bigStep=1,
								get=function() return main.opt.timersMobyell[n] and main.opt.timersMobyell[n].timerDuration or 0 end,
								set=function(info, value) if not main.opt.timersMobyell[n] then main.opt.timersMobyell[n] = {timerDuration=value, sourceNames={}} main:updateOptions() else main.opt.timersMobyell[n].timerDuration = value end end,
								order=2,
							},
							allowMultiples = {
								type="toggle",
								name="Allow multiple instances",
								order=3,
								width="full",
								get=function() if main.opt.timersMobyell[n] then return (not main.opt.timersMobyell[n].noMultiples) else return true end end,
								set=function(info, value) if not main.opt.timersMobyell[n] then main.opt.timersMobyell[n] = {noMultiples=(not value),sourceNames={}} main:updateOptions() else main.opt.timersMobyell[n].noMultiples = not value end end,
							},
						},
					},
					messageSource={
						type="group",
						name="Message source",
						order=2,
						dialogInline=true,
						hidden=function() return (not main.opt.timersMobyell[n]) end,
						args={
							filterSource={
								type="toggle",
								name="Filter message source",
								get=function() return main.opt.timersMobyell[n].filterSource end,
								set=function(info, value) main.opt.timersMobyell[n].filterSource = value end,
								order=1,
							},
							filterNames={
								type="group",
								name="Source names",
								order=2,
								dialogInline=true,
								hidden=function() return (not main.opt.timersMobyell[n].filterSource) end,
								args={
									addName={
										order=1,
										type="input",
										name="Add name",
										get=function() return "" end,
										set=function(info, value) main.opt.timersMobyell[n].sourceNames[value] = value end,
										width="full",
									},
									removeName={
										order=2,
										type="multiselect",
										name="Remove name",
										hidden=function() return (not next(main.opt.timersMobyell[n].sourceNames, nil)) end,
										values=function() return main.opt.timersMobyell[n].sourceNames end,
										width="full",
										get=function() return false end,
										set=function(info, name) main.opt.timersMobyell[n].sourceNames[name] = nil end,
									},
									addTarget={
										type="execute",
										order=3,
										width="full",
										name="Add current target",
										func=function() if UnitExists("target") then local name =UnitName("target") main.opt.timersMobyell[n].sourceNames[name] = name end end,
									},
								},
							},
						},
					},
					messageContent={
						type="group",
						name="Message content",
						order=3,
						dialogInline=true,
						hidden=function() return (not main.opt.timersMobyell[n]) end,
						args={
							isPattern={
								type="toggle",
								name="Is Lua pattern",
								desc="Lua patterns allow for more intricate filtering of messages",
								get=function() return main.opt.timersMobyell[n].filterIsPattern end,
								set=function(info, value) main.opt.timersMobyell[n].filterIsPattern = value end,
								order=1,
								width="full",
							},
							messageFilter={
								type="input",
								name="Message filter",
								desc="Leave empty if you do not want to filter this",
								get=function() return main.opt.timersMobyell[n].messageFilter or "" end,
								set=function(info, value) main.opt.timersMobyell[n].messageFilter = value end,
								order=1,
								width="full",
							},
						},
					},
					delete={
						type="execute",
						func=function() tremove(main.opt.timersMobyell, n) end,
						name="Delete this filter",
						width="full",
						order=4,
						confirm=true,
						confirmText="Are you sure you want to delete this filter?",
						hidden=function() return (not main.opt.timersMobyell[n]) end,
					},
				},
			}
		end
	end
	for n=1, (#main.opt.timersCustom+1) do
		if not main.options.args.customtimers.args["timer"..n] then
			main.options.args.customtimers.args["timer"..n] = {
				type="group",
				name=function()
					if not main.opt.timersCustom[n] then
						return "New filter"
					end
					if main.opt.timersCustom[n].timerName then
						return main.opt.timersCustom[n].timerName
					end
					return "Unnamed custom timer"
				end,
				hidden=function() return ((#main.opt.timersCustom+1)<n) end,
				order=n,
				args={
					defaultSettings={
						type="group",
						name="Default settings",
						order=1,
						dialogInline=true,
						args = {
							timerName = {
								type="input",
								order=1,
								name="Bar label",
								desc="You can override those by returning values in your function",
								get=function() return main.opt.timersCustom[n] and main.opt.timersCustom[n].timerName or "" end,
								set=function(info, value) if not main.opt.timersCustom[n] then main.opt.timersCustom[n] = {timerName=value,events={}} main:updateOptions() else main.opt.timersCustom[n].timerName = value end end,
							},
							timerDuration = {
								type="range",
								name="Bar duration",
								min=0.1,
								softMax=1200,
								bigStep=1,
								get=function() return main.opt.timersCustom[n] and main.opt.timersCustom[n].timerDuration or 0 end,
								set=function(info, value) if not main.opt.timersCustom[n] then main.opt.timersCustom[n] = {timerDuration=value,events={}} main:updateOptions() else main.opt.timersCustom[n].timerDuration = value end end,
								order=2,
							},
							allowMultiples = {
								type="toggle",
								name="Allow multiple instances",
								order=3,
								width="full",
								get=function() if main.opt.timersCustom[n] and (type(main.opt.timersCustom[n].noMultiples) == "boolean") then return (not main.opt.timersCustom[n].noMultiples) else return true end end,
								set=function(info, value) if not main.opt.timersCustom[n] then main.opt.timersCustom[n] = {noMultiples=(not value)} else main.opt.timersCustom[n].noMultiples=(not value) end end,
							},
						},
					},
					eventSettings={
						type="group",
						name="Event settings",
						order=2,
						dialogInline=true,
						hidden=function() return (not main.opt.timersCustom[n]) end,
						args={
							addEvent = {
								name="Add event",
								type="input",
								order=1,
								get=function() return "" end,
								width="full",
								set=function(info, value) main.opt.timersCustom[n].events[value] = value main:doEvents() end,
							},
							removeEvents = {
								hidden=function() return (not next(main.opt.timersCustom[n].events, nil)) end,
								name="Remove events",
								type="multiselect",
								values=function() return main.opt.timersCustom[n].events end,
								width="full",
								order=2,
								get=function() return false end,
								set=function(info, event) main.opt.timersCustom[n].events[event] = nil main:doEvents() end,
							},
						},
					},
					code={
						type="input",
						multiline=true,
						name="Filter code",
						desc="You can override the default timer duration or label by returning values (return 1 is duration, return 2 is label)",
						order=3,
						width="full",
						hidden=function() return (not main.opt.timersCustom[n]) end,
						get=function() return main.opt.timersCustom[n].stringFilter or "" end,
						set=function(info, value) main.opt.timersCustom[n].stringFilter = value end,
					},
					delete={
						type="execute",
						func=function() tremove(main.opt.timersCustom, n) end,
						name="Delete this filter",
						width="full",
						order=4,
						confirm=true,
						confirmText="Are you sure you want to delete this filter?",
						hidden=function() return (not main.opt.timersCustom[n]) end,
					},
				},
			}
		end
	end
end
SlashCmdList["CBMT"]=function(input)
	local createargs = input:match("create%s+(.+)")
	if createargs then
		local duration, label = createargs:match("(%d+)%s+(.+)")
		duration = tonumber(duration)
		if duration and label then
			main:createTimer(duration, label, true)
		else
			print("|cffffff00Proper syntax: |r/cbmt create <duration> <label>")
		end
		return
	end
	LibStub("AceConfigDialog-3.0"):Open("CBMT")
end
SLASH_CBMT1="/cbmt"